var AG = {}; /* Global object */

AG.impressionCheckEvent = 'impressionCheckEvent';

AG.dispatchImpressionCheckEvent = function () {
    window.dispatchEvent(new Event(AG.impressionCheckEvent));
};

AG.openOfferClickUrl = function (url) {
    mraid.open(url);
};

AG.isWholeElementInViewport = function (el) {
    var rect = el.getBoundingClientRect();

    return (rect.width !== 0 && rect.height !== 0) &&

    (
        rect.top >= 0 &&
        rect.left >= 0 &&
        rect.bottom <= (window.innerHeight || document.documentElement.clientHeight) && /*or $(window).height() */
        rect.right <= (window.innerWidth || document.documentElement.clientWidth) /*or $(window).width() */
    );
};


AG.isPartOfElementInViewport = function (el) {
    var rect     = el.getBoundingClientRect(),
        vWidth   = window.innerWidth || doc.documentElement.clientWidth,
        vHeight  = window.innerHeight || doc.documentElement.clientHeight,
        efp      = function (x, y) { return document.elementFromPoint(x, y) };

    /* Return false if it's not in the viewport */
    if (rect.right < 0 || rect.bottom < 0
        || rect.left > vWidth || rect.top > vHeight)
        return false;

    /* Return true if any of its four corners are visible */
    return (
        el.contains(efp(rect.left,  rect.top))
        ||  el.contains(efp(rect.right, rect.top))
        ||  el.contains(efp(rect.right, rect.bottom))
        ||  el.contains(efp(rect.left,  rect.bottom))
    );
};


AG.reportImpression = function (url) {

    var request = new XMLHttpRequest();
    request.open('GET', url, true);
    request.send();
};




(function () {

    var startTrackingImpressions = function () {
        var scrollView = document.querySelector('[data-scroll-view]') || window;
        var impressionableEls = document.querySelectorAll('[data-impression-url]');

        Array.prototype.forEach.call(impressionableEls, function (impressionableEl) {
            var onVisibilityChange = function () {

                if (AG.isWholeElementInViewport(impressionableEl)) {
                    AG.reportImpression(impressionableEl.dataset.impressionUrl);

                    window.removeEventListener('DOMContentLoaded', onVisibilityChange, false);
                    window.removeEventListener(AG.impressionCheckEvent, onVisibilityChange, false);
                    scrollView.removeEventListener('scroll', onVisibilityChange, false);
                    window.removeEventListener('resize', onVisibilityChange, false);
                }
            };

            window.addEventListener('DOMContentLoaded', onVisibilityChange, false);
            window.addEventListener(AG.impressionCheckEvent, onVisibilityChange, false);
            scrollView.addEventListener('scroll', onVisibilityChange, false);
            window.addEventListener('resize', onVisibilityChange, false);
        });
    };

    document.addEventListener("DOMContentLoaded", function (event) {
        /* if there is no custom custom impression mechanism (like in carousel), run the default impression mechanism */
        if (document.querySelector('[data-custom-impression-mechanism]') === null) {
            startTrackingImpressions();
        }
    });


}());